-- Author: Fetty42
-- Date: 04.04.2022
-- Version: 1.1.0.0


AutoLightOnOff = {};

AutoLightOnOff.updateDelta = 2001;    	-- time since the last update
AutoLightOnOff.updateRate = 2000;  	-- milliseconds until next update
AutoLightOnOff.hasTurnedAutoLightOn = {}	-- Stores the info if the last activation was automatic


function AutoLightOnOff:update(dt)
	AutoLightOnOff.updateDelta = AutoLightOnOff.updateDelta + dt;
	
	if g_currentMission.player == nil and g_currentMission.controlledVehicle == nil then
		-- print("  No player or controlled vehicle!");
		return;
    end;

	if AutoLightOnOff.updateDelta > AutoLightOnOff.updateRate then
		-- print("AutoLightOnOff:update");
		AutoLightOnOff.updateDelta = 0;
		if g_currentMission:getIsClient() and g_gui.currentGui == nil then
    		local needLights = not g_currentMission.environment.isSunOn
			local curVehicle = g_currentMission.controlledVehicle;

			-- print("***AutoLightOnOff:update: Light Control***")
			if curVehicle ~= nil and curVehicle.spec_lights ~= nil then
				if curVehicle.getIsAIActive == nil or not curVehicle:getIsAIActive() then
					local isLightActive = AutoLightOnOff:getIsLightTurnedOn(curVehicle)

					if needLights and (AutoLightOnOff.hasTurnedAutoLightOn[curVehicle] == nil or not AutoLightOnOff.hasTurnedAutoLightOn[curVehicle]) then
						AutoLightOnOff.hasTurnedAutoLightOn[curVehicle] = true
					end

					if not isLightActive and needLights then
						-- turn light on
						curVehicle:setNextLightsState(curVehicle.spec_lights.numLightTypes);
					end;
					if isLightActive and not needLights and AutoLightOnOff.hasTurnedAutoLightOn[curVehicle] then
						-- turn light off
						curVehicle:deactivateLights(true);
						AutoLightOnOff.hasTurnedAutoLightOn[curVehicle] = false
					end;
				end;
			elseif g_currentMission.player ~= nil then
				if needLights and (AutoLightOnOff.hasTurnedAutoLightOn[g_currentMission.player] == nil or not AutoLightOnOff.hasTurnedAutoLightOn[g_currentMission.player]) then
					AutoLightOnOff.hasTurnedAutoLightOn[g_currentMission.player] = true
				end

				if not g_currentMission.player.isTorchActive and needLights then
					-- turn light on
					g_currentMission.player:setLightIsActive(true)
				end
				if g_currentMission.player.isTorchActive and not needLights and AutoLightOnOff.hasTurnedAutoLightOn[g_currentMission.player] then
					-- turn light off
					g_currentMission.player:setLightIsActive(false)
					AutoLightOnOff.hasTurnedAutoLightOn[g_currentMission.player] = false
				end
			end;
		end;
	end;
end;

function AutoLightOnOff:getIsLightTurnedOn(vehObj)
	if vehObj.spec_lights ~= nil and vehObj.spec_lights.currentLightState > 0 then
		return true;
	else
		return false
	end;
end;

-- function AutoLightOnOff:loadMap(name)end;
-- function AutoLightOnOff:registerActionEvents() end;
-- function AutoLightOnOff:onLoad(savegame)end;
-- function AutoLightOnOff:onUpdate(dt)end;
-- function AutoLightOnOff:deleteMap()end;
-- function AutoLightOnOff:keyEvent(unicode, sym, modifier, isDown)end;
-- function AutoLightOnOff:mouseEvent(posX, posY, isDown, isUp, button)end;
-- function AutoLightOnOff:draw()end;

addModEventListener(AutoLightOnOff);